﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace howto_reconstruct_tree
{
    public class Node
    {
        public Node Left, Right;
        public string Value;

        public Node(string value)
        {
            Value = value;
            Left = null;
            Right = null;
        }

        public string Inorder()
        {
            string result = "";
            if (Left != null) result += Left.Inorder();
            result += Value;
            if (Right != null) result += Right.Inorder();
            return result;
        }

        public string Preorder()
        {
            string result = Value;
            if (Left != null) result += Left.Preorder();
            if (Right != null) result += Right.Preorder();
            return result;
        }

        public string Dump(int indent)
        {
            string result = new String(' ', indent) + Value + "\r\n";
            if (Left != null) result += Left.Dump(indent + 4);
            if (Right != null) result += Right.Dump(indent + 4);
            return result;
        }
    }
}
