﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_reconstruct_tree
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Node a = BuildTestTree();
            //txtTree.Text = a.Dump(0);
            txtPreorder.Text = a.Preorder();
            txtInorder.Text = a.Inorder();
        }

        private void btnEvaluate_Click(object sender, EventArgs e)
        {
            Node root = ReconstructTree(
                txtPreorder.Text, txtInorder.Text);
            txtTree.Text = root.Dump(0);
        }

        private Node BuildTestTree()
        {
            Node a = new Node("A");
            Node b = new Node("B");
            Node c = new Node("C");
            Node d = new Node("D");
            Node e = new Node("E");
            Node f = new Node("F");
            Node g = new Node("G");
            Node h = new Node("H");
            Node i = new Node("I");
            a.Left = b;
            a.Right = c;
            b.Left = d;
            b.Right = e;
            d.Left = g;
            c.Right = f;
            f.Left = h;
            f.Right = i;
            return a;
        }

        private Node ReconstructTree(
                string preorder, string inorder)
        {
            Node root = new Node(preorder[0].ToString());
            int pos = inorder.IndexOf(preorder[0]);

            string inorder1 = inorder.Substring(0, pos);
            string inorder2 = inorder.Substring(pos + 1);
            string preorder1 = preorder.Substring(1, inorder1.Length);
            string preorder2 = preorder.Substring(inorder1.Length + 1);

            if (inorder1.Length > 0)
            {
                root.Left = ReconstructTree(preorder1, inorder1);
            }
            if (inorder2.Length > 0)
            {
                root.Right = ReconstructTree(preorder2, inorder2);
            }

            return root;
        }
    }
}
